


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for api/utils/__init__.py: 4%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>api/utils/__init__.py</b> :
            <span class="pc_cov">4%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            51 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">1 run</span>
            <span class="mis shortkey_m button_toggle_mis">50 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="stm mis"><a href="#n1">1</a></p>
<p id="n2" class="stm mis"><a href="#n2">2</a></p>
<p id="n3" class="stm mis"><a href="#n3">3</a></p>
<p id="n4" class="stm mis"><a href="#n4">4</a></p>
<p id="n5" class="stm mis"><a href="#n5">5</a></p>
<p id="n6" class="stm mis"><a href="#n6">6</a></p>
<p id="n7" class="stm mis"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="stm mis"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="stm mis"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="stm mis"><a href="#n13">13</a></p>
<p id="n14" class="stm mis"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="stm mis"><a href="#n17">17</a></p>
<p id="n18" class="stm mis"><a href="#n18">18</a></p>
<p id="n19" class="stm mis"><a href="#n19">19</a></p>
<p id="n20" class="stm mis"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="stm mis"><a href="#n22">22</a></p>
<p id="n23" class="stm mis"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="stm mis"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="pln"><a href="#n28">28</a></p>
<p id="n29" class="stm mis"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="stm mis"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="pln"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="stm mis"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="stm mis"><a href="#n48">48</a></p>
<p id="n49" class="pln"><a href="#n49">49</a></p>
<p id="n50" class="stm mis"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="stm mis"><a href="#n52">52</a></p>
<p id="n53" class="stm mis"><a href="#n53">53</a></p>
<p id="n54" class="stm mis"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="stm mis"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="stm mis"><a href="#n60">60</a></p>
<p id="n61" class="stm mis"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="stm mis"><a href="#n67">67</a></p>
<p id="n68" class="stm mis"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm mis"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="stm mis"><a href="#n75">75</a></p>
<p id="n76" class="pln"><a href="#n76">76</a></p>
<p id="n77" class="pln"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="pln"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="pln"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="stm mis"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>

            </td>
            <td class="text">
<p id="t1" class="stm mis"><span class="key">import</span> <span class="nam">arrow</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="stm mis"><span class="key">import</span> <span class="nam">json</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="stm mis"><span class="key">import</span> <span class="nam">random</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="stm mis"><span class="key">import</span> <span class="nam">string</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="stm mis"><span class="key">import</span> <span class="nam">base64</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="stm mis"><span class="key">import</span> <span class="nam">re</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="stm mis"><span class="key">import</span> <span class="nam">os</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t9" class="stm mis"><span class="key">from</span> <span class="nam">flask</span> <span class="key">import</span> <span class="nam">current_app</span><span class="op">,</span> <span class="nam">request</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t11" class="stm mis"><span class="key">from</span> <span class="nam">math</span> <span class="key">import</span> <span class="nam">ceil</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t13" class="stm mis"><span class="key">def</span> <span class="nam">allowed_file</span><span class="op">(</span><span class="nam">filename</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="stm mis">    <span class="key">return</span> <span class="str">'.'</span> <span class="key">in</span> <span class="nam">filename</span> <span class="key">and</span> <span class="xx">\</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln">           <span class="nam">filename</span><span class="op">.</span><span class="nam">rsplit</span><span class="op">(</span><span class="str">'.'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="op">.</span><span class="nam">lower</span><span class="op">(</span><span class="op">)</span> <span class="key">in</span> <span class="nam">current_app</span><span class="op">.</span><span class="nam">config</span><span class="op">.</span><span class="nam">get</span><span class="op">(</span><span class="str">'ALLOWED_EXTENSIONS'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm mis"><span class="key">def</span> <span class="nam">get_clients_ip</span><span class="op">(</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm mis">    <span class="nam">headers_list</span> <span class="op">=</span> <span class="nam">request</span><span class="op">.</span><span class="nam">headers</span><span class="op">.</span><span class="nam">getlist</span><span class="op">(</span><span class="str">"X-Forwarded-For"</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm mis">    <span class="nam">user_ip</span> <span class="op">=</span> <span class="nam">headers_list</span><span class="op">[</span><span class="num">0</span><span class="op">]</span> <span class="key">if</span> <span class="nam">headers_list</span> <span class="key">else</span> <span class="nam">request</span><span class="op">.</span><span class="nam">remote_addr</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm mis">    <span class="key">return</span> <span class="nam">user_ip</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm mis"><span class="key">def</span> <span class="nam">generate_sms_token</span><span class="op">(</span><span class="nam">phone</span><span class="op">=</span><span class="str">''</span><span class="op">,</span> <span class="nam">n</span><span class="op">=</span><span class="num">6</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm mis">    <span class="key">return</span> <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">random</span><span class="op">.</span><span class="nam">SystemRandom</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_uppercase</span> <span class="op">+</span> <span class="nam">string</span><span class="op">.</span><span class="nam">digits</span> <span class="op">+</span> <span class="nam">phone</span><span class="op">)</span> <span class="key">for</span> <span class="nam">_</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm mis"><span class="key">def</span> <span class="nam">generate_unique_id</span><span class="op">(</span><span class="nam">n</span><span class="op">=</span><span class="num">16</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run">    <span class="key">return</span> <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">random</span><span class="op">.</span><span class="nam">SystemRandom</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">choice</span><span class="op">(</span><span class="nam">string</span><span class="op">.</span><span class="nam">ascii_uppercase</span> <span class="op">+</span> <span class="nam">string</span><span class="op">.</span><span class="nam">digits</span> <span class="op">+</span> <span class="nam">str</span><span class="op">(</span><span class="nam">arrow</span><span class="op">.</span><span class="nam">utcnow</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">timestamp</span><span class="op">)</span><span class="op">)</span> <span class="key">for</span> <span class="nam">_</span> <span class="key">in</span> <span class="nam">range</span><span class="op">(</span><span class="nam">n</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t28" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm mis"><span class="key">def</span> <span class="nam">parse_verification_token</span><span class="op">(</span><span class="nam">token</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">        <span class="nam">payload</span> <span class="op">=</span> <span class="nam">json</span><span class="op">.</span><span class="nam">loads</span><span class="op">(</span><span class="nam">base64</span><span class="op">.</span><span class="nam">urlsafe_b64decode</span><span class="op">(</span><span class="nam">str</span><span class="op">(</span><span class="nam">token</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm mis">        <span class="key">return</span> <span class="nam">payload</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">    <span class="key">except</span> <span class="nam">ValueError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="key">return</span> <span class="nam">None</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis"><span class="key">def</span> <span class="nam">normalize_phone_number</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">    <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">    <span class="key">if</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">startswith</span><span class="op">(</span><span class="str">'08'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">        <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">replace</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">[</span><span class="op">:</span><span class="num">2</span><span class="op">]</span><span class="op">,</span> <span class="str">'628'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">    <span class="key">elif</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">startswith</span><span class="op">(</span><span class="str">'+628'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm mis">        <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">replace</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">[</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">,</span> <span class="str">'628'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">    <span class="key">return</span> <span class="nam">phone</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm mis"><span class="key">def</span> <span class="nam">denormalize_phone_number</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm mis">    <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm mis">    <span class="key">if</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">startswith</span><span class="op">(</span><span class="str">'628'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm mis">        <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">replace</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">[</span><span class="op">:</span><span class="num">3</span><span class="op">]</span><span class="op">,</span> <span class="str">'08'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm mis">    <span class="key">elif</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">startswith</span><span class="op">(</span><span class="str">'+628'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">        <span class="nam">phone</span> <span class="op">=</span> <span class="nam">phone_number</span><span class="op">.</span><span class="nam">replace</span><span class="op">(</span><span class="nam">phone_number</span><span class="op">[</span><span class="op">:</span><span class="num">4</span><span class="op">]</span><span class="op">,</span> <span class="str">'08'</span><span class="op">,</span> <span class="num">1</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm mis">    <span class="key">return</span> <span class="nam">phone</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm mis"><span class="key">def</span> <span class="nam">is_file_exist</span><span class="op">(</span><span class="nam">path</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm mis">    <span class="key">return</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">exists</span><span class="op">(</span><span class="nam">path</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis"><span class="key">def</span> <span class="nam">is_dir_exist</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">    <span class="key">if</span> <span class="key">not</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">exists</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">dirname</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm mis">            <span class="nam">os</span><span class="op">.</span><span class="nam">makedirs</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">dirname</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm mis">        <span class="key">except</span> <span class="nam">OSError</span> <span class="key">as</span> <span class="nam">exc</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">            <span class="key">if</span> <span class="nam">exc</span><span class="op">.</span><span class="nam">errno</span> <span class="op">!=</span> <span class="nam">errno</span><span class="op">.</span><span class="nam">EEXIST</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">                <span class="key">raise</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm mis"><span class="key">def</span> <span class="nam">valid_url</span><span class="op">(</span><span class="nam">url</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm mis">    <span class="nam">regex</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">compile</span><span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="pln">        <span class="str">r'^(?:http|ftp)s?://'</span> <span class="com"># http:// or https://</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="pln">        <span class="str">r'(?:(?:[A-Z0-9](?:[A-Z0-9-]{0,61}[A-Z0-9])?\.)+(?:[A-Z]{2,6}\.?|[A-Z0-9-]{2,}\.?)|'</span> <span class="com">#domain...</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln">        <span class="str">r'localhost|'</span> <span class="com">#localhost...</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="pln">        <span class="str">r'\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})'</span> <span class="com"># ...or ip</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln">        <span class="str">r'(?::\d+)?'</span> <span class="com"># optional port</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="pln">        <span class="str">r'(?:/?|[/?]\S+)$'</span><span class="op">,</span> <span class="nam">re</span><span class="op">.</span><span class="nam">IGNORECASE</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t83" class="stm mis">    <span class="key">return</span> <span class="nam">re</span><span class="op">.</span><span class="nam">match</span><span class="op">(</span><span class="nam">regex</span><span class="op">,</span> <span class="nam">url</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln"><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-10-29 23:19
        </p>
    </div>
</div>

</body>
</html>
